package ru.landgrafhomyak.db.skeleton1.api.statement

import ru.landgrafhomyak.db.skeleton1.api.DatabaseType

public interface StatementIODeclarationScope<@Suppress("unused") sUE : Any, @Suppress("unused") IK : Any> {
	public interface Input<sUE : Any, IK : Any> : StatementIODeclarationScope<sUE, IK> {
		public fun <RT> inputParam(type: DatabaseType.ImplementationsProvider<RT>): InputParam<RT, sUE, IK>
	}

	public interface Output<sUE : Any, IK : Any> : StatementIODeclarationScope<sUE, IK> {
		public fun <RT> outputColumn(type: DatabaseType.ImplementationsProvider<RT>): OutputColumn<RT, sUE, IK>
	}

	public interface InputOutput<sUE : Any, IK : Any> : StatementIODeclarationScope<sUE, IK>, Input<sUE, IK>, Output<sUE, IK>
}